summaryrefslogtreecommitdiffstats
path: root/tests/rscript_unflatten_conflict1.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-15 16:28:20 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-15 16:28:20 +0000
commitdcc721a95bef6f0d8e6d8775b8efe33e5aecd562 (patch)
tree66a2774cd0ee294d019efd71d2544c70f42b2842 /tests/rscript_unflatten_conflict1.sh
parentInitial commit. (diff)
downloadrsyslog-dcc721a95bef6f0d8e6d8775b8efe33e5aecd562.tar.xz
rsyslog-dcc721a95bef6f0d8e6d8775b8efe33e5aecd562.zip
Adding upstream version 8.2402.0.upstream/8.2402.0
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to '')
-rwxr-xr-xtests/rscript_unflatten_conflict1.sh43
1 files changed, 43 insertions, 0 deletions
diff --git a/tests/rscript_unflatten_conflict1.sh b/tests/rscript_unflatten_conflict1.sh
new file mode 100755
index 0000000..27040e2
--- /dev/null
+++ b/tests/rscript_unflatten_conflict1.sh
@@ -0,0 +1,43 @@
+#!/bin/bash
+# added 2021-03-09 by Julien Thomas, released under ASL 2.0
+
+source "${srcdir:=.}/diag.sh" init
+export RSYSLOG_DEBUG="debug nostdout"
+export RSYSLOG_DEBUGLOG="$RSYSLOG_DYNNAME.debug"
+
+generate_conf
+add_conf '
+module(load="../plugins/imtcp/.libs/imtcp")
+module(load="../contrib/fmunflatten/.libs/fmunflatten")
+input(type="imtcp" port="0" listenPortFileName="'"$RSYSLOG_DYNNAME"'.tcpflood_port")
+template(name="outfmt" type="string" string="%msg% %$.ret% %$.unflatten%\n")
+
+if (not($msg contains "msgnum:")) then
+ stop
+
+set $!a!b = "foo";
+set $!a.b.c = "bar";
+set $.unflatten = unflatten($!, ".");
+set $.ret = script_error();
+action(type="omfile" file=`echo $RSYSLOG_OUT_LOG` template="outfmt")
+'
+startup
+tcpflood -m 1
+wait_file_lines "$RSYSLOG_OUT_LOG" 1 60
+shutdown_when_empty
+wait_shutdown
+
+# this test may need changes to produce a more deterministic
+# output by sorting keys
+EXPECTED=' msgnum:00000000: 0 { "a": { "b": { "c": "bar" } } }'
+cmp_exact "$RSYSLOG_OUT_LOG"
+
+EXPECTED='fmunflatten.c: warning: while processing flat key "a.b.c" at depth #1 (intermediate node), overriding existing value of type string by an object'
+if ! grep -F "$EXPECTED" "$RSYSLOG_DEBUGLOG"; then
+ echo "GREP FAILED"
+ echo " => FILE: $RSYSLOG_DEBUGLOG"
+ echo " => EXPECTED: $EXPECTED"
+ error_exit 1
+fi
+
+exit_test